#include <windows.h>
#include <stdio.h>

static char cmdline[32768];

int WINAPI WinMain(HINSTANCE hi, HINSTANCE hpi, LPSTR cmd, int show)
{
	HWND win;
	DWORD thread;
	HMODULE dll;
	HOOKPROC func;
	HHOOK hook;
	DWORD code;

	STARTUPINFO startup;
        PROCESS_INFORMATION pi;

	int ret = 1;

	dll = LoadLibrary("GrimCam.dll");
	if (!dll)
	{
		return ret;
	}

	func = (void *)GetProcAddress(dll, "Grim_MouseHook");

	memset(&startup, 0, sizeof(STARTUPINFO));
	memset(&pi, 0, sizeof(PROCESS_INFORMATION));

	snprintf(cmdline, 32768, "\"Grim Dawn.exe\" %s", cmd);

	SetEnvironmentVariable("SteamAppId", "219990");

	if (func && CreateProcess("Grim Dawn.exe", cmdline, 0, 0, 0, 0, 0, 0, &startup, &pi))
	{
		while(GetExitCodeProcess(pi.hProcess, &code) && code == STILL_ACTIVE)
                {
                        win = 0;

			while ((win = FindWindowEx(0, win, "Grim Dawn", "Grim Dawn")))
			{
				DWORD pid;
                                thread = GetWindowThreadProcessId(win, &pid);
                                if (thread && pid == pi.dwProcessId)
                                {
                                        goto found;
                                }
			}

			Sleep(1000);
		}

		if (0)
		{
	found:
			hook = SetWindowsHookEx(WH_MOUSE, func, dll, thread);
                        if (hook)
                        {
                                WaitForSingleObject(pi.hProcess, INFINITE);
	                        UnhookWindowsHookEx(hook);
                                ret = 0;
			}
                }

		CloseHandle(pi.hThread);
                CloseHandle(pi.hProcess);
        }

        FreeLibrary(dll);

	return ret;
}
